#include "dsp_oddcastUI.h"
#include "dsp.h"
#include <mad.h>
#include "liboddcast.h"

/*
#include "../SDK/dsp.h"
#include "../SDK/config.h"
#include "../SDK/initquit.h"
#include "../SDK/play_callback.h"
#include "../SDK/play_control.h"
#include "../SDK/file_info_helper.h"
#include "../SDK/reader.h"
#include "../SDK/reader_helper_mem.h"
#include "../SDK/tagread.h"
#include "../SDK/input.h"
#include "../SDK/metadb.h"
#include "../SDK/component.h"
*/
#include "../SDK/foobar2000.h"



#include "config.h"
#include <math.h>
#include "resource.h"
#include "transcode.h"

extern transcodeGlobals	globals;

static int isShown = 0;
//static cfg_int oddcast_show_on_startup("dsp_oddcastv2",0);//in 0.1 dB

class dsp_oddcastv2 : public dsp_i_base
{
public:
	virtual GUID get_guid()
	{
		static const GUID guid = 
		{ 0x9281e42c, 0xc58e, 0x4425, { 0x8b, 0xc2, 0xab, 0xb4, 0x46, 0xc1, 0x32, 0x97 } };
		return guid;
	}

	virtual const char * get_name() { return "Oddcast V2";}

	virtual bool on_chunk(audio_chunk *chunk)
	{
		if (!isShown) {
			frameShowHide(SW_SHOW);
			isShown = 1;
		}
		  if (getIsConnected()) {
			  if (!getLiveRecordingFlag()) {
				  int nsamples  = chunk->get_sample_count();
				  int nch = chunk->get_channels();
				  int srate = chunk->get_srate();
				  float *samples = (float *)malloc(nsamples*nch*sizeof(float));
				  audio_sample *psample = chunk->get_data();
		  		  for (int i=0;i<nsamples*nch;i++) {
					  audio_sample sample = *psample++;
  					  samples[i] = (sample);
				  }
				  handle_output((float *)samples, nsamples, nch, srate);
				  if (samples) {
					  free(samples);
				  }
			  }
		  }
		  return true;
	}

};
class initquit_oddcast : public initquit
{
public:
	virtual void on_init()
	{
		int a = 1;
		char filename[512],*p;
		char	directory[1024] = "";
		char currentDir[1024] = "";


		memset(filename, '\000', sizeof(filename));
		GetModuleFileName(NULL,filename,sizeof(filename));
		strcpy(currentDir, filename);
		char *pend;
		pend = strrchr(currentDir, '\\');
		if (pend) {
			*pend = '\000';
		}
		p = filename+lstrlen(filename);
		while (p >= filename && *p != '\\') p--;
		p++;

		char	logFile[1024] = "";
		char	configFile[1024] = "";
		char	currentlogFile[1024] = "";
		memset(logFile, '\000', sizeof(logFile));
		char *p2 = strchr(p, '.');
		if (p2) {
			strncpy(logFile, p, p2-p);
		}
		else {
			strcpy(logFile, p);
		}
		strcpy(logFile, "oddcastv2_foo");
		sprintf(configFile, "%s\\%s.cfg", currentDir, logFile);
		sprintf(currentlogFile, "%s\\%s.log", currentDir, logFile);

		setLogFile(currentlogFile);
		setConfigFileName(configFile);

		wxString commandLine = "";
		wxEntry((WXHINSTANCE) GetModuleHandle(NULL), (WXHINSTANCE) NULL, NULL, SW_HIDE, FALSE);
	}
	virtual void on_quit()
	{
		writeConfigFile();
		closeItDown();
	}

	static GUID get_class_guid();
};


static playlist_entry_i now_playing;

class oddcast_play_callback_ui : public play_callback
{
	virtual void on_playback_starting()
	{
	}
	virtual void on_playback_new_track(metadb_handle * track)
	{
		string8		out;
		string8		fullTitle = "";

		track->handle_query_meta_field("ARTIST", 0, out);
		fullTitle.add_string(out);
		track->handle_query_meta_field("TITLE", 0, out);
		fullTitle.add_string(" - ");
		fullTitle.add_string(out);

		if (!strcmp(fullTitle.get_ptr(), " - ")) {
			char *fullpath = strdup(track->handle_get_path());
			if (fullpath) {
				char	*partialPath = strrchr(fullpath, '\\');
				if (partialPath) {
					partialPath++;
					char *extention = strrchr(partialPath, '.');
					if (extention) {
						*extention = '\000';
					}
					setUIMetadata(partialPath);
				}
				else {
					setUIMetadata(fullpath);
				}
				free(fullpath);
			}
		}
		else {
			setUIMetadata((char *)fullTitle.get_ptr());
		}


	}
	virtual void on_playback_stop(play_control::stop_reason reason)
	{
		;
	}
	virtual void on_playback_seek(double time)
	{
		;
	}
	virtual void on_playback_pause(int state)
	{
		;
	}
	virtual void on_playback_edited(metadb_handle * track)
	{
		;
	}
	virtual void on_playback_dynamic_info(const file_info * info,bool b_track_change)
	{
		;
	}
	virtual void on_volume_change(int new_val) {};

};

static service_factory_single_t<dsp,dsp_oddcastv2> odd_foo;
static service_factory_single_t<initquit,initquit_oddcast> odd_foo_init;
static service_factory_single_t<play_callback,oddcast_play_callback_ui> odd_foo_play_callback;
